HDU 1969 Pie(二分+模拟)

来源:互联网 发布:java代码大全下载 编辑:程序博客网 时间:2024/06/05 05:30

My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though. 

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size. 

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.
Input
One line with a positive integer: the number of test cases. Then for each test case:
  • One line with two integers N and F with 1 ≤ N, F ≤ 10 000: the number of pies and the number of friends.
  • One line with N integers ri with 1 ≤ ri ≤ 10 000: the radii of the pies.
Output
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10 −3.
Sample Input
33 34 3 31 24510 51 4 2 3 4 5 6 5 4 2
Sample Output
25.13273.141650.2655

题解:

很坑的一题,用g++交如果输出的时候是%lf就一直wa,还有精度要注意,题目并不难,是一个二分题

代码:

#include<iostream>#include<stdio.h>#include<map>#include<algorithm>#include<math.h>#include<queue>#include<stack>#include<string>#include<cstring>using namespace std;const double PI=acos(-1.0);//为了精度double a[10005];int cmp(const double& x,const double& y){    return x>y;}int main(){    int i,j,k,n,m,test,ans,r;    double minn,maxx,d,t;    scanf("%d",&test);    while(test--)    {        maxx=0;        scanf("%d%d",&n,&m);        m++;        for(i=0;i<n;i++)        {            scanf("%d",&r);            a[i]=r*r*PI;            maxx+=a[i];        }        sort(a,a+n,cmp);//其实可以不排序的感觉        minn=0.0;        maxx/=m;        while(fabs(maxx-minn)>0.000001)//二分运行的条件        {            ans=0;            t=(minn+maxx)/2;            for(i=0;i<n;i++)            {                ans+=(int)(a[i]/t);            }            if(ans>=m)            {                minn=t;            }            else                maxx=t;        }        printf("%.4f\n",t);//神坑,用%lf就一直wa    }    return 0;}